---
title: Create Entry with Controls
description: This POST /directory/v1 operation adds a _controls property to the requests and responses for these APIs. The property is an array of JSON formatted controls that are used to include additional content in LDAP requests and responses. For more information about supported controls, refer to Controls.
component: pingdirectory
page_id: pingdirectory:directory:directory-entry-apis/create-entry-with-controls
canonical_url: https://developer.pingidentity.com/pingdirectory/directory/directory-entry-apis/create-entry-with-controls.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Entry with Controls

##

```none
POST {{apiPath}}/directory/v1
```

This `POST /directory/v1` operation adds a `_controls` property to the requests and responses for these APIs. The property is an array of JSON formatted controls that are used to include additional content in LDAP requests and responses. For more information about supported controls, refer to [Controls](#controls).

The sample shows a create request that includes two controls, a generate password request control and an intermediate client request control.

The response body includes an additional `_controls` property that shows the two controls specified in the request. Note that the generated password request control includes the generated password in the response.

When successful, the response returns a `201 Created` message.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
        "type": "work",
        "value": "unauth1@example.com"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/directory/v1' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data-raw '{
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
        "type": "work",
        "value": "unauth1@example.com"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/directory/v1")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""_dn"": ""uid=user1,ou=people,dc=example,dc=com""," + "\n" +
@"    ""objectClass"": [" + "\n" +
@"        ""top""," + "\n" +
@"        ""ubidPerson""" + "\n" +
@"    ]," + "\n" +
@"    ""uid"": ""user1""," + "\n" +
@"    ""userPassword"": ""userpassword1""," + "\n" +
@"    ""cn"": ""UnauthorizedUserUnauthUser1""," + "\n" +
@"    ""sn"": ""UnauthUser1""," + "\n" +
@"    ""c"": ""United States""," + "\n" +
@"    ""ubidEmailJSON"": {" + "\n" +
@"        ""type"": ""work""," + "\n" +
@"        ""value"": ""unauth1@example.com""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/directory/v1"
  method := "POST"

  payload := strings.NewReader(`{
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
        "type": "work",
        "value": "unauth1@example.com"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /directory/v1 HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
        "top",
        "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
        "type": "work",
        "value": "unauth1@example.com"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"_dn\": \"uid=user1,ou=people,dc=example,dc=com\",\n    \"objectClass\": [\n        \"top\",\n        \"ubidPerson\"\n    ],\n    \"uid\": \"user1\",\n    \"userPassword\": \"userpassword1\",\n    \"cn\": \"UnauthorizedUserUnauthUser1\",\n    \"sn\": \"UnauthUser1\",\n    \"c\": \"United States\",\n    \"ubidEmailJSON\": {\n        \"type\": \"work\",\n        \"value\": \"unauth1@example.com\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/directory/v1")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/directory/v1",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
      "top",
      "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
      "type": "work",
      "value": "unauth1@example.com"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/directory/v1',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "_dn": "uid=user1,ou=people,dc=example,dc=com",
    "objectClass": [
      "top",
      "ubidPerson"
    ],
    "uid": "user1",
    "userPassword": "userpassword1",
    "cn": "UnauthorizedUserUnauthUser1",
    "sn": "UnauthUser1",
    "c": "United States",
    "ubidEmailJSON": {
      "type": "work",
      "value": "unauth1@example.com"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/directory/v1"

payload = json.dumps({
  "_dn": "uid=user1,ou=people,dc=example,dc=com",
  "objectClass": [
    "top",
    "ubidPerson"
  ],
  "uid": "user1",
  "userPassword": "userpassword1",
  "cn": "UnauthorizedUserUnauthUser1",
  "sn": "UnauthUser1",
  "c": "United States",
  "ubidEmailJSON": {
    "type": "work",
    "value": "unauth1@example.com"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/directory/v1');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "_dn": "uid=user1,ou=people,dc=example,dc=com",\n    "objectClass": [\n        "top",\n        "ubidPerson"\n    ],\n    "uid": "user1",\n    "userPassword": "userpassword1",\n    "cn": "UnauthorizedUserUnauthUser1",\n    "sn": "UnauthUser1",\n    "c": "United States",\n    "ubidEmailJSON": {\n        "type": "work",\n        "value": "unauth1@example.com"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/directory/v1")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "_dn": "uid=user1,ou=people,dc=example,dc=com",
  "objectClass": [
    "top",
    "ubidPerson"
  ],
  "uid": "user1",
  "userPassword": "userpassword1",
  "cn": "UnauthorizedUserUnauthUser1",
  "sn": "UnauthUser1",
  "c": "United States",
  "ubidEmailJSON": {
    "type": "work",
    "value": "unauth1@example.com"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"_dn\": \"uid=user1,ou=people,dc=example,dc=com\",\n    \"objectClass\": [\n        \"top\",\n        \"ubidPerson\"\n    ],\n    \"uid\": \"user1\",\n    \"userPassword\": \"userpassword1\",\n    \"cn\": \"UnauthorizedUserUnauthUser1\",\n    \"sn\": \"UnauthUser1\",\n    \"c\": \"United States\",\n    \"ubidEmailJSON\": {\n        \"type\": \"work\",\n        \"value\": \"unauth1@example.com\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/directory/v1")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "schemas": [
            {
                "href": "https://ds.example.com/directory/v1/schemas/inetOrgPerson"
            }
        ],
        "self": {
            "href": "https://ds.example.com/directory/v1/uid=johnsmith,ou=people,dc=example,dc=com"
        }
    },
    "objectClass": [
        "top",
        "inetOrgPerson",
        "organizationalPerson",
        "person"
    ],
    "sn": [
        "Smith"
    ],
    "cn": [
        "John"
    ],
    "givenName": [
        "John"
    ],
    "title": [
        "TheDescriptionForJohn"
    ],
    "uid": [
        "johnsmith"
    ],
    "_dn": "uid=johnsmith,ou=people,dc=example,dc=com",
    "_controls": [
        {
            "oid": "1.3.6.1.4.1.30221.2.5.2",
            "control-name": "Intermediate Client Response Control",
            "criticality": false,
            "value-json": {
                "server-name": "PingDirectory",
                "server-session-id": "conn=16872",
                "server-response-id": "op=1"
            }
        },
        {
            "oid": "1.3.6.1.4.1.30221.2.5.59",
            "control-name": "Generate Password Response Control",
            "criticality": false,
            "value-json": {
                "generated-password": "349T86abwRt",
                "must-change-password": false
            }
        }
    ]
}
```
